//+------------------------------------------------------------------+
//|                                                 RogueTrader      |
//|                                                       c0deZ      |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "SenexInv exp. 10.15.09"
#property link      "SenexInv.com"
//+--------------------------------------------------------------------------------------------------+
//|  Works off several indicators to derermine entry                                                 |
//   Exists on stop loss or on take profit                                                           |
//+--------------------------------------------------------------------------------------------------+
//---- input parameters


extern double    Lots=0.1;
extern double    MM= 0;
extern int       Stoploss=1000;
extern int       TakeProfit=150;
extern bool      MainTrail = False;
extern double    TrailingStop1 = 50;
extern double    TrailingStop2 = 70;
extern double    TrailingStop3 = 50;
extern double    TrailingStop4 = 50;
extern int       Slip=5;
extern int       Step=5;
extern int       StartHour = 0;
extern int       EndHour = 24;
extern int       APeriod = 50;
extern int       RPeriod = 10;
string           eaname = "RogueTrader 1.023941";
extern int       MaxOrders = 3;
extern bool      hedge = true;
extern bool      SingleOrderBar = True; 
extern int       Magicnum = 15;


//----
double b4plusdi,b4minusdi,nowplusdi,nowminusdi,Opentrades,total,TradesInThisSymbol,bp,malong,masignal,cci,sm,ss,Lot;
int ordTotal;
int BarsCount = 0;
//---- indicators
int init()
  {
 
  
//----
   return(0);
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//| Setting internal variables for quick access to data              |
//+------------------------------------------------------------------+
int start()
  {
  
   //if (Opentrades!=0)  //and iATR(5,2)<StopLoss*Point 
   
     //{
      
      string expire_date = "2009.10.15"; //<-- hard coded datetime
      datetime e_d = StrToTime(expire_date);

      if (CurTime() >= e_d)
      {
      Alert (eaname + " - The trial version has been expired! Contact Developer"); 
      }
      
      total=OrdersTotal();      
      int tradeTotal=OrdersTotal()-1;
      
      //Main Trailing Stop
      if (MainTrail == True){
         for(int i=tradeTotal ; i>=0 ; i--)
         {
            if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==true)   
            {
               if (OrderType()==OP_BUY)
               {
                  if(TrailingStop1>0.0)
                  {
                     if(Bid-OrderOpenPrice()>Point*TrailingStop1) 
                     {
                        if(OrderStopLoss()<Bid-Point*TrailingStop1)
                        {
                           
                           OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop1,(OrderTakeProfit()+(Step)),0,Blue);
                           return(0);
                        }
                     }
                  }
               }
      
               if (OrderType()==OP_SELL)
               {
                  if(TrailingStop1>0.0)
                  {
                     if(OrderOpenPrice()-Ask>Point*TrailingStop1) 
                     {
                        if(OrderStopLoss()>Ask+Point*TrailingStop1)
                        {
                           OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop1,(OrderTakeProfit()-(Step)),0,Red);
                           return(0);
                        }
                     }
                  }
                 }
               }
            }
      
      
      }
      
      //First Trailing Stop
      if (MainTrail == False){
      if(OrderSelect(1,SELECT_BY_POS,MODE_TRADES)==true)   
      {
         if (OrderType()==OP_BUY)
         {
         if(TrailingStop1>0.0)
         {
         if(Bid-OrderOpenPrice()>Point*TrailingStop1) 
          {
           if(OrderStopLoss()<Bid-Point*TrailingStop1)
             {
              OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop1,(OrderTakeProfit()+(Step)),0,Blue);
              return(0);
             }
          }
         }
         }
      
         if (OrderType()==OP_SELL)
         {
         if(TrailingStop1>0.0)
         {
         if(OrderOpenPrice()-Ask>Point*TrailingStop1) 
          {
           if(OrderStopLoss()>Ask+Point*TrailingStop1)
             {
              OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop1,(OrderTakeProfit()+(Step)),0,Blue);
              return(0);
             }
          }
         }
         
      }
   }
   //second trailing stop
    
   if(OrderSelect(2,SELECT_BY_POS,MODE_TRADES)==true)   
      {
         if (OrderType()==OP_BUY)
         {
         if(TrailingStop2>0.0)
         {
         if(Bid-OrderOpenPrice()>Point*TrailingStop2) 
          {
           if(OrderStopLoss()<Bid-Point*TrailingStop2)
             {
              OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop2,(OrderTakeProfit()+(Step)),0,Blue);
              return(0);
             }
          }
         }
         }
      
         if (OrderType()==OP_SELL)
         {
         if(TrailingStop2>0.0)
         {
         if(OrderOpenPrice()-Ask>Point*TrailingStop2) 
          {
           if(OrderStopLoss()>Ask+Point*TrailingStop2)
             {
              OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop2,(OrderTakeProfit()-(Step)),0,Blue);
              return(0);
             }
          }
         }
         
      }
   }
    
   //Third Trailing Stop
    if(OrderSelect(3,SELECT_BY_POS,MODE_TRADES)==true)   
      {
         if (OrderType()==OP_BUY)
         {
         if(TrailingStop3>0.0)
         {
         if(Bid-OrderOpenPrice()>Point*TrailingStop3) 
          {
           if(OrderStopLoss()<Bid-Point*TrailingStop3)
             {
              OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop3,(OrderTakeProfit()+(Step)),0,Blue);
              return(0);
             }
          }
         }
         }
      
         if (OrderType()==OP_SELL)
         {
         if(TrailingStop3>0.0)
         {
         if(OrderOpenPrice()-Ask>Point*TrailingStop3) 
          {
           if(OrderStopLoss()>Ask+Point*TrailingStop3)
             {
              OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop3,(OrderTakeProfit()-(Step)),0,Blue);
              return(0);
             }
          }
         }
         
      }
   }
      //Trailing Stop for 4
      
      
      if(OrderSelect(0,SELECT_BY_POS,MODE_TRADES)==true)   
      {
         if (OrderType()==OP_BUY)
         {
         if(TrailingStop4>0.0)
         {
         if(Bid-OrderOpenPrice()>Point*TrailingStop4) 
          {
           if(OrderStopLoss()<Bid-Point*TrailingStop4)
             {
              OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop4,(OrderTakeProfit()+(Step)),0,Blue);
              return(0);
             }
          }
         }
         }
      
         if (OrderType()==OP_SELL)
         {
         if(TrailingStop4>0.0)
         {
         if(OrderOpenPrice()-Ask>Point*TrailingStop4) 
          {
           if(OrderStopLoss()>Ask+Point*TrailingStop4)
             {
              OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop4,(OrderTakeProfit()-(Step)),0,Blue);
              return(0);
             }
          }
         }
         
      }
      }}
            
      if(Hour() < StartHour) return(0); // Too early

      if(Hour() > EndHour) return(0); // Too late
  
  
  //       double momC = iMomentum(NULL,0,14,PRICE_CLOSE,2);
  //       double momP = iMomentum(NULL,0,14,PRICE_CLOSE,1);
         b4plusdi=iADX(NULL,0,APeriod,PRICE_CLOSE,MODE_PLUSDI,2);
         nowplusdi=iADX(NULL,0,APeriod,PRICE_CLOSE,MODE_PLUSDI,1); 
         b4minusdi=iADX(NULL,0,APeriod,PRICE_CLOSE,MODE_MINUSDI,2);
         nowminusdi=iADX(NULL,0,APeriod,PRICE_CLOSE,MODE_MINUSDI,1);
         //nowadx=iADX(NULL,0,14,PRICE_LOW,MODE_MAIN,1);
         //double cci=iCCI(0,0,5,PRICE_TYPICAL,0);
         double rvim=iRVI(0,0,RPeriod,MODE_MAIN,1);
         double rvis=iRVI(0,0,RPeriod,MODE_SIGNAL,0);
         //malong=iMACD(0,0,10,26,9,PRICE_CLOSE,MODE_MAIN,0);
         //masignal=iMACD(0,0,10,26,9,PRICE_CLOSE,MODE_SIGNAL,1);
         //bp=iBullsPower(0,0,100,PRICE_CLOSE,1);
         sm=iStochastic(0,0,14,14,3,MODE_SMA,0,MODE_MAIN,0);
         //ss=iStochastic(0,0,14,14,10,MODE_SMA,0,MODE_SIGNAL,1);

      //Comment (nowplusdi);
      //+------------------------------------------------------------------+
      //| Money Management mm=0(lots) mm=-1(Mini) mm=1(full compounding)   |
      //+------------------------------------------------------------------+   
      
      
      
      //calculates all open orders
      ordTotal = 0;
      for (int j =0; j<OrdersTotal(); j++)
      {
         OrderSelect(j,SELECT_BY_POS,MODE_TRADES);
         if (OrderSymbol()==Symbol() && OrderMagicNumber() == Magicnum)
            { ordTotal++; }  // end of if statement
      }  // end of for loop

   
      //----

      //+------------------------------------------------------------------+
      //|                                                                  |
      //+------------------------------------------------------------------+
         //Single Orders
         if(SingleOrderBar == True){      
         if (Bars > BarsCount){        
        
         if(b4plusdi<b4minusdi && nowplusdi>nowminusdi)//Checks the main adx parameters
             {
              if(rvim>rvis)//checks to make sure main rvis is higher than the signal
              {
                  if(sm<=40){
                  if(total<=MaxOrders-1)
                  {
                     if(hedge == true)
                     {
                        OrderSend(Symbol(),OP_BUY,Lots(),Ask,Slip,Ask-Stoploss*Point,Ask+TakeProfit*Point,eaname,Magicnum,0,Blue);
                        BarsCount = Bars;
                        return;
                     }
                     if(hedge == false)
                     {
                        if(total == 0)
                        {
                           OrderSend(Symbol(),OP_BUY,Lots(),Ask,Slip,Ask-Stoploss*Point,Ask+TakeProfit*Point,eaname,Magicnum,0,Blue);
                           BarsCount = Bars;
                           return;
                        }                 
                        if(total>0)
                        {
                           if(OrderSelect(1,SELECT_BY_POS)== OP_BUY)
                           {
                              OrderSend(Symbol(),OP_BUY,Lots(),Ask,Slip,Ask-Stoploss*Point,Ask+TakeProfit*Point,eaname,Magicnum,0,Blue);
                              BarsCount = Bars;
                           }
                           if(OrderSelect(1,SELECT_BY_POS)==OP_SELL)
                           {
                              return;
                           }   
                        }
                     }}
                  }
              }
           }
              
          
          if(b4plusdi>b4minusdi && nowplusdi<nowminusdi)
            {
               if (rvis>rvim)
               {
                  if (sm>=80){
                  if(total<=MaxOrders-1)
                  {
                     if (hedge == True)
                     {                  
                        OrderSend(Symbol(),OP_SELL,Lots(),Bid,Slip,Bid+Stoploss*Point,Bid-TakeProfit*Point,eaname,Magicnum,0,Red);      
                        BarsCount = Bars;
                     }
                     if (hedge == false)
                     {
                        if (total == 0)
                        {
                           OrderSend(Symbol(),OP_SELL,Lots(),Bid,Slip,Bid+Stoploss*Point,Bid-TakeProfit*Point,eaname,Magicnum,0,Red);
                           BarsCount = Bars;
                           return;   
                        }   
                        if (total>0)
                        {
                           if (OrderSelect(1,SELECT_BY_POS) == OP_SELL)
                           {
                              OrderSend(Symbol(),OP_SELL,Lots(),Bid,Slip,Bid+Stoploss*Point,Bid-TakeProfit*Point,eaname,Magicnum,0,Red);
                              BarsCount = Bars;
                              return;
                           }
                           if (OrderSelect(1,SELECT_BY_POS) == OP_BUY){
                              return;
                           }   
                        
                        }                 
                      }
                   }}
                 }
              }
           
       BarsCount = Bars;     
       }}
   
       //-------------------------------------------------------------------------------------------------------
       // No single Orders
       if(SingleOrderBar == false){
       
       if(b4plusdi<b4minusdi && nowplusdi>nowminusdi)//Checks the main adx parameters
             {
              if(rvim>rvis)//checks to make sure main rvis is higher than the signal
              {
                  if(sm<=40){
                  if(total<=MaxOrders-1)
                  {
                     if(hedge == true)
                     {
                        OrderSend(Symbol(),OP_BUY,Lots(),Ask,Slip,Ask-Stoploss*Point,Ask+TakeProfit*Point,eaname,Magicnum,0,Blue);
                        
                        return;
                     }
                     if(hedge == false)
                     {
                        if(total == 0)
                        {
                           OrderSend(Symbol(),OP_BUY,Lots(),Ask,Slip,Ask-Stoploss*Point,Ask+TakeProfit*Point,eaname,Magicnum,0,Blue);
                           
                           return;
                        }                 
                        if(total>0)
                        {
                           if(OrderSelect(1,SELECT_BY_POS)== OP_BUY)
                           {
                              OrderSend(Symbol(),OP_BUY,Lots(),Ask,Slip,Ask-Stoploss*Point,Ask+TakeProfit*Point,eaname,Magicnum,0,Blue);
                              
                           }
                           if(OrderSelect(1,SELECT_BY_POS)==OP_SELL)
                           {
                              return;
                           }   
                        }
                     }}
                  }
              }
           }
              
          
          if(b4plusdi>b4minusdi && nowplusdi<nowminusdi)
            {
               if (rvis>rvim)
               {
                  if (sm>=80){
                  if(total<=MaxOrders-1)
                  {
                     if (hedge == True)
                     {                  
                        OrderSend(Symbol(),OP_SELL,Lots(),Bid,Slip,Bid+Stoploss*Point,Bid-TakeProfit*Point,eaname,Magicnum,0,Red);      
                        
                     }
                     if (hedge == false)
                     {
                        if (total == 0)
                        {
                           OrderSend(Symbol(),OP_SELL,Lots(),Bid,Slip,Bid+Stoploss*Point,Bid-TakeProfit*Point,eaname,Magicnum,0,Red);
                           
                           return;   
                        }   
                        if (total>0)
                        {
                           if (OrderSelect(1,SELECT_BY_POS) == OP_SELL)
                           {
                              OrderSend(Symbol(),OP_SELL,Lots(),Bid,Slip,Bid+Stoploss*Point,Bid-TakeProfit*Point,eaname,Magicnum,0,Red);
                              
                              return;
                           }
                           if (OrderSelect(1,SELECT_BY_POS) == OP_BUY){
                              return;
                           }   
                        
                        }                 
                      }
                   }}
                 }
              }
       
       
       
       }
   
   

   string sComment   = "";
   string sp         = "----------------------------------------\n";
   string NL         = "\n";
   string sDirection = "";
   sComment = eaname + NL;
   sComment = sComment + "Stop Loss = " + DoubleToStr(Stoploss,0) + " | "; 
   sComment = sComment + "Take Profit = " + DoubleToStr(TakeProfit,0) + " | ";
   sComment = sComment + "Main Trailing Stop = " + DoubleToStr(TrailingStop1,0) + NL;   
   sComment = sComment + sp;   
   sComment = sComment + "Lots = " + Lots + " | " + "Current Open Orders = " + ordTotal + NL;
   sComment = sComment + "Max Orders = " + MaxOrders + NL; 
   sComment = sComment + "ADX Period = " +APeriod + " | " + " RVI Period = " + RPeriod + NL; 
   //sComment = sComment + "sig_sell=" + DoubleToStr(sig_sell,Digits) + NL; 
   sComment = sComment + sp;  
   Comment(sComment);
   
   
   return(0);
   }
  // }
     
double Lots()                                            // Calculation of lots
   {
//============================================================================================
   Lot=NormalizeDouble(AccountEquity()*MM/100/1000,1);// Calculate the amoung of lots  
   double Min_Lot = MarketInfo(Symbol(), MODE_MINLOT);   // Minimum permissible cost of lots
   if (Lot == 0 ) Lot = Lots;                         // For testing on const.min.lots
//============================================================================================
   return(Lot);
   }

